/**********************************************************************
 *
 * sqldbclass.h -- 
 * Copyright (C) 2008  DL Consulting Ltd
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *********************************************************************/

#ifndef SQLDBCLASS_H
#define SQLDBCLASS_H


#include "dbclass.h"
#include "text_t.h"


class sqldbclass : public dbclass
{
public:
  sqldbclass() {}
  virtual ~sqldbclass() {}


  // -----------------------------------------------------------------------------------------------
  // These functions MUST be implemented by subclasses, as they are database-specific

  // returns array of document OIDs
  virtual text_tarray get_documents_with_metadata_value (const text_t &metadata_element_name,
							 const text_t &metadata_value,
							 const text_t &sort_by_metadata_element_name) = 0;

  // returns array of values
  virtual text_tarray get_metadata_values (const text_t &metadata_element_name,
					   const text_t &metadata_value_filter) = 0;
};


#endif
